program exercise15
  implicit none
  double precision, dimension(1:3,1:3) :: amat, bmat, cmat  !3x3の２次元配列を３つ宣言
  integer :: i, j, k

  open(12, file="matrixa.dat", status="old", action="read") ! 装置番号12としてmatrixa.datファイルを読み込み専用で開く
  do i = 1, 3
     read(12,*) amat(i,1), amat(i,2), amat(i,3)             ! matrixa.datから実数３つずつを読み込んでamatに代入
  end do
  close(12)                                                 ! ファイルmatrixa.datを閉じる

  open(unit=13, file="matrixb.dat", status="old", action="read") ! 同じことをmatrixb.datに対して行う。手前で閉じていれば装置番号12を使いまわしてもよい。
  do i = 1, 3
     read(13,*) (bmat(i,j), j = 1, 3)
  end do
  close(unit=13)

  cmat = 0.0d0   ! cmatを初期化
  do j = 1, 3
     do i = 1, 3
        do k = 1, 3
           cmat(i,j) = cmat(i,j) + amat(i,k) * bmat(k,j)  !行列の積を計算
        end do
     end do
  end do

  open(14, file="matrixc.dat", status="unknown", action="write") ! 計算結果を出力するファイルを装置番号14としてmatrixc.datとして開く。存在しない場合はファイルが作成される
  do i = 1, 3
     write(14,*) (cmat(i,j), j = 1, 3)                           ! cmatをmatrixc.datに書き出す
  end do
  close(14)                                                      ! ファイルmatrixc.datを閉じる
  
end program exercise15
